/*____________________________________________________________________________
	Copyright (C) 1997 Network Associates Inc. and affiliated companies.
	All rights reserved.

	$Id: CGADurationEditField.h,v 1.2 1999/03/10 02:33:50 heller Exp $
____________________________________________________________________________*/
#pragma once

#include <LCommander.h>
#include <LCaption.h>

typedef enum DurationType
{
	kDateDurationType = 0,
	kLengthDurationType,
	kTimeDurationType
} DurationType;

enum	{	kDownAdjust = -1, kUpAdjust = 1 };

class CGADurationEditField :	public LCaption,
								public LCommander
{
public:
	enum { class_ID = 'gDEF' };
	
						CGADurationEditField(LStream * inStream);
						~CGADurationEditField();
						
	void				SetDurationType(DurationType type);
	void				SetDurationValue(UInt32 duration);
	UInt32				GetDurationValue();	// returns seconds
	virtual void		AdjustValue(Int16 direction);

	virtual Boolean		HandleKeyPress(const EventRecord&	inKeyEvent);
	virtual void		DrawSelf();
	virtual void		FinishCreateSelf();
	virtual void		ClickSelf(
							const SMouseDownEvent & inMouseDown);
	virtual void		AdjustCursorSelf(
							Point				inPortPt,
							const EventRecord &	inMacEvent);
	virtual void		BeTarget();
	virtual void		DontBeTarget();
	
protected:
	void				DrawBackground(const Rect & localFrame);
	void				DrawBox(const Rect & localFrame);
	void				DrawGrayBox(const Rect & localFrame);
	void				DrawText(const Rect & localFrame);
	Boolean				ValidDay(Int16 month, Int16 day, Int16 year);
private:
	
	DurationType		mType;
	Int16				mSelectedSection;
	Int16				mHorizontalCutoffs[4];
	Int16				mValues[4];
};

